=== debian/changelog ===
arm-trusted-firmware (2.12.1+dfsg-1) unstable; urgency=medium

  * New upstream point release.
    Fixes CVE-2024-7881 CVE-2024-5660
  * debian/copyright: Update for 2.12.1.
  * debian/copyright: Update to Standards-Version 4.7.2.
  * debian/patches: Drop patch to make warnings nonfatal.
    (Closes: #1091147)

 -- Vagrant Cascadian <vagrant@debian.org>  Sun, 02 Mar 2025 11:37:27 -0800
