=== debian/watch ===
version=4

opts=mode=git,\
     dversionmangle=auto,\
     filenamemangle=s/.*trusted-firmware-a-(.*)/@PACKAGE@-$1/,\
     repacksuffix=+dfsg,\
     uversionmangle=s/-rc/~rc/ \
  https://review.trustedfirmware.org/TF-A/trusted-firmware-a.git refs/tags/(?:lts-)?v(\d\S*)
